#include "common_def.h"
#include "mem_def.h"
#include "sys_lib_motion.h"
#include "sys_lib_extension_type.h"
#include "cam.inc"

// Globale memory
MemM __mem = {0};
MemI __mem_input = {0};
MemQ __mem_output = {0};

// Globale variables
__DECLARE_RESOURCE(default_resource,
    __DECLARE_VAR_SYS(AXIS_REF,Axis_0);
    __DECLARE_VAR(BOOL,A1);
);

// POUs
#include "pous.inc"

// TASKs
// -- Mast --
Main Mast_Main_1={0};
PlcAppRet task_Mast_init(void)
{
    PlcAppRet ret = (PlcAppRet){kPlcApp_Success,NULL};
    ret = main_init__(&Mast_Main_1);
    if(ret.code!=kPlcApp_Success)
        return ret;
    __INIT_EXTERNAL_SYS(Mast_Main_1.,Axis_0,default_resource);
    return ret;
}

int task_Mast_run(void)
{
    main_body__(&Mast_Main_1);
    return 0;
}

int task_Mast_trigger(void)
{
    return 0;
}

// -- Stop1 --
Stop_interPUT Stop1_Stop_interPUT_1={0};
PlcAppRet task_Stop1_init(void)
{
    PlcAppRet ret = (PlcAppRet){kPlcApp_Success,NULL};
    ret = stop_interput_init__(&Stop1_Stop_interPUT_1);
    if(ret.code!=kPlcApp_Success)
        return ret;
    __INIT_EXTERNAL_SYS(Stop1_Stop_interPUT_1.,Axis_0,default_resource);
    return ret;
}

int task_Stop1_run(void)
{
    stop_interput_body__(&Stop1_Stop_interPUT_1);
    return 0;
}

int task_Stop1_trigger(void)
{
    static bool state_d = 0;
    bool state = __GET_VAR(,GLOBAL_VAR(default_resource,A1),);
    int trig = (state&&(!state_d)) ? 1 : 0;
    state_d = state;
    return trig;
}

// RESOURCE
PlcAppRet resource_default_init__(void)
{
    const char* name = NULL;

    name = sys_lib_load_misc();
    if(name!=NULL)
        return (PlcAppRet){kPlcApp_SysLibApiNotFound,name};
    name = sys_lib_load_motion();
    if(name!=NULL)
        return (PlcAppRet){kPlcApp_SysLibApiNotFound,name};

    memset(&resource_default_resource,0,sizeof(resource_default_resource));
    __INIT_GLOBAL(default_resource,Axis_0,__INITIAL_VALUE(AXIS_REF,{.index=0}));

    if(plc_create_task("Mast", 15, 5 * 1000, task_Mast_init, task_Mast_run, task_Mast_trigger)!=0)
        return (PlcAppRet){kPlcApp_CreateTaskFailed,"Mast"};
    if(plc_create_task("Stop1", 0, 0, task_Stop1_init, task_Stop1_run, task_Stop1_trigger)!=0)
        return (PlcAppRet){kPlcApp_CreateTaskFailed,"Stop1"};

    return (PlcAppRet){kPlcApp_Success,NULL};
}

#include "plc_vars.inc"

// CONFIGURATION
PlcAppRet configuration_default_init(void)
{
    return resource_default_init__();
}

