#include "common_def.h"
#include "user_def.h"
#include "mem_def.h"
#include "sys_lib_misc.h"
#include "sys_lib_modbus.h"
#include "sys_lib_motion.h"
#include "sys_lib_extension.h"
#include "sys_lib_extension_type.h"
#include "sys_lib_raw.h"
// PROGRAM Main
typedef struct 
{
    __DECLARE_FB(MC_Power,MC_POWER_1);
    __DECLARE_FB(MC_Jog_Legacy,MC_JOG_1);
    __DECLARE_VAR(BOOL,JOG1);
    __DECLARE_VAR(REAL,JOGV);
    __DECLARE_EXTERNAL_SYS(AXIS_REF,Axis_0);
} Main;

PlcAppRet main_init__(Main *data__);
PlcAppRet main_init__(Main *data__)
{
    __INIT_FB(data__->,MC_POWER_1,MC_Power);
    __INIT_FB(data__->,MC_JOG_1,MC_Jog_Legacy);
    return (PlcAppRet){kPlcApp_Success,NULL};
}
void main_body__(Main *data__)
{
    BOOL ENO = TRUE;
    plc_update_start();
    __INPUT_UPDATE_EXTERNAL(data__->,Axis_0);
    plc_update_end();
    __CALL_FB(MC_Power,data__->MC_POWER_1,
        TRUE,
        __CALL_PARAM(
            __SET_INPUT(data__->MC_POWER_1.,Enable,,TRUE);
            __SET_INPUT(data__->MC_POWER_1.,Axis,,__GET_EXTERNAL(data__->,Axis_0,));
        ),
        __CALL_OUTPUT(
        )
    );

    __CALL_FB(MC_Jog_Legacy,data__->MC_JOG_1,
        TRUE,
        __CALL_PARAM(
            __SET_INPUT(data__->MC_JOG_1.,Velocity,,__GET_VAR(data__->,JOGV,));
            __SET_INPUT(data__->MC_JOG_1.,Acceleration,,10000.0);
            __SET_INPUT(data__->MC_JOG_1.,Deceleration,,10000.0);
            __SET_INPUT(data__->MC_JOG_1.,Jog,,__GET_VAR(data__->,JOG1,));
            __SET_INPUT(data__->MC_JOG_1.,Axis,,__GET_EXTERNAL(data__->,Axis_0,));
        ),
        __CALL_OUTPUT(
        )
    );

}

// PROGRAM Stop_interPUT
typedef struct 
{
    __DECLARE_FB(MC_ImmediateStop,MC_IMMEDIATESTOP_1);
    __DECLARE_EXTERNAL_SYS(AXIS_REF,Axis_0);
} Stop_interPUT;

PlcAppRet stop_interput_init__(Stop_interPUT *data__);
PlcAppRet stop_interput_init__(Stop_interPUT *data__)
{
    __INIT_FB(data__->,MC_IMMEDIATESTOP_1,MC_ImmediateStop);
    return (PlcAppRet){kPlcApp_Success,NULL};
}
void stop_interput_body__(Stop_interPUT *data__)
{
    BOOL ENO = TRUE;
    plc_update_start();
    __INPUT_UPDATE_EXTERNAL(data__->,Axis_0);
    plc_update_end();
    __CALL_FB(MC_ImmediateStop,data__->MC_IMMEDIATESTOP_1,
        TRUE,
        __CALL_PARAM(
            __SET_INPUT(data__->MC_IMMEDIATESTOP_1.,Axis,,__GET_EXTERNAL(data__->,Axis_0,));
        ),
        __CALL_OUTPUT(
        )
    );

}

